local FirstLootEver = FirstLootEver
local pairs, select =
	  pairs, select
local localfuncs = (select(2,...))
local GetItemInfo = localfuncs.gii
local GetItemQualityColor = localfuncs.giqc
local UnitName, GetNumRaidMembers, UnitLevel =
	  UnitName, GetNumRaidMembers, UnitLevel

localfuncs.registerAchievements = function()

FirstLootEver:RegisterAchievement(1, "Anything goes", "Obtain any item.", "Interface\\Icons\\Spell_Shaman_ImprovedReincarnation", function() return true end, {}, "General", nil, 2)
FirstLootEver:RegisterAchievement(2, "A starter's collection", "Obtain 25 different items",
	"Interface\\Icons\\Achievement_GuildPerk_MobileBanking",
	function(addon)
		if addon:HasAchievement(1) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 25 then
					break
				end
			end
			return (c >= 25)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c>=25 then
					break
				end
			end
			return "Obtain 25 different items", 0, (c>=25), c, 25, (UnitName("player")), 1, 0, c.." / 25", "FirstLootEver_2_1", true
		end,
	},
	"General",
	1,
	3
)
FirstLootEver:RegisterAchievement(3, "I'm all outta titles", "Obtain 50 different items.",
	"Interface\\Icons\\Spell_Arcane_FocusedPower",
	function(addon)
		if addon:HasAchievement(2) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 50 then
					break
				end
			end
			return (c >= 50)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c>=50 then
					break
				end
			end
			return "Obtain 50 different items", 0, (c>=50), c, 50, (UnitName("player")), 1, 0, c.." / 50", "FirstLootEver_3_1", true
		end,
	},
	"General",
	2,
	4
)
FirstLootEver:RegisterAchievement(4, "Three digits", "Obtain 100 different items.",
	"Interface\\Icons\\Achievement_GuildPerk_MobileBanking",
	function(addon)
		if addon:HasAchievement(3) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 100 then
					break
				end
			end
			return (c >= 100)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c>=100 then
					break
				end
			end
			return "Obtain 100 different items", 0, (c>=100), c, 100, (UnitName("player")), 1, 0, c.." / 100", "FirstLootEver_4_1", true
		end,
	},
	"General",
	3,
	5
)
FirstLootEver:RegisterAchievement(5, "Double up", "Obtain 200 different items.",
	"Interface\\AddOns\\FirstLootEver\\DoubleUp",
	function(addon)
		if addon:HasAchievement(4) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 200 then
					break
				end
			end
			return (c >= 200)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 200 then
					break
				end
			end
			return "Obtain 200 different items", 0, (c>=200), c, 200, (UnitName("player")), 1, 0, c.." / 200", "FirstLootEver_5_1", true
		end,
	},
	"General",
	4,
	6
)
FirstLootEver:RegisterAchievement(6, "Tonight We Dine In Hell", "Obtain 300 different items.",
	"Interface\\AddOns\\FirstLootEver\\Sparta",
	function(addon)
		if addon:HasAchievement(5) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 300 then
					break
				end
			end
			return (c >= 300)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 300 then
					break
				end
			end
			return "Obtain 300 different items", 0, (c>=300), c, 300, (UnitName("player")), 1, 0, c.." / 300", "FirstLootEver_6_1", true
		end,
	},
	"General",
	5,
	7
)
FirstLootEver:RegisterAchievement(7,"Halfway to Checkpoint Alpha", "Obtain 500 different items.",
	"Interface\\Icons\\Achievement_Quests_Completed_02",
	function(addon)
		if addon:HasAchievement(6) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 500 then
					break
				end
			end
			return (c >= 500)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 500 then
					break
				end
			end
			return "Obtain 500 different items", 0, (c>=500), c, 500, (UnitName("player")), 1, 0, c.." / 500", "FirstLootEver_7_1", true
		end,
	},
	"General",
	6,
	8
)
FirstLootEver:RegisterAchievement(8,"Three Quarters", "Obtain 750 different items.",
	"Interface\\Icons\\Achievement_General_100kDAILYquests",
	function(addon)
		if addon:HasAchievement(7) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 750 then
					break
				end
			end
			return (c >= 750)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 750 then
					break
				end
			end
			return "Obtain 750 different items", 0, (c>=750), c, 750, (UnitName("player")), 1, 0, c.." / 750", "FirstLootEver_8_1", true
		end,
	},
	"General",
	7,
	9
)
FirstLootEver:RegisterAchievement(9,"First! (But not last)", "Obtain 1000 different items.",
	"Interface\\Icons\\ACHIEVEMENT_GUILDPERK_HONORABLEMENTION",
	function(addon)
		if addon:HasAchievement(8) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 1000 then
					break
				end
			end
			return (c >= 1000)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 1000 then
					break
				end
			end
			return "Obtain 1000 different items", 0, (c>=1000), c, 1000, (UnitName("player")), 1, 0, c.." / 1000", "FirstLootEver_9_1", true
		end,
	},
	"General",
	8,
	10
)
FirstLootEver:RegisterAchievement(10,"Needs Moar Itemz","Obtain 1500 different items.",
	"Interface\\Icons\\Achievement_Quests_Completed_04",
	function(addon)
		if addon:HasAchievement(8) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 1500 then
					break
				end
			end
			return (c >= 1500)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 1500 then
					break
				end
			end
			return "Obtain 1500 different items", 0, (c>=1500), c, 1500, (UnitName("player")), 1, 0, c.." / 1500", "FirstLootEver_10_1", true
		end,
	},
	"General",
	9,
	11
)
FirstLootEver:RegisterAchievement(11, "Here goes another one!","Obtain 2000 different items.",
	"Interface\\Icons\\ACHIEVEMENT_GUILDPERK_HONORABLEMENTION_RANK2",
	function(addon)
		if addon:HasAchievement(8) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 2000 then
					break
				end
			end
			return (c >= 2000)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 2000 then
					break
				end
			end
			return "Obtain 2000 different items", 0, (c>=2000), c, 2000, (UnitName("player")), 1, 0, c.." / 2000", "FirstLootEver_11_1", true
		end,
	},
	"General",
	10,
	12
)
FirstLootEver:RegisterAchievement(12, "That's a lot of items","Obtain 5000 different items.",
	"Interface\\Icons\\Achievement_Guild_Level5",
	function(addon)
		if addon:HasAchievement(8) then
			local c=0
			for id in pairs(addon.savedVar.items) do
				c=c+1
				if c >= 5000 then
					break
				end
			end
			return (c >= 5000)
		end
	end,
	{
		function(ns)
			local c=0
			for id in pairs(FirstLootEver.savedVar.items) do
				c=c+1
				if c >= 5000 then
					break
				end
			end
			return "Obtain 5000 different items", 0, (c>=5000), c, 5000, (UnitName("player")), 1, 0, c.." / 5000", "FirstLootEver_12_1", true
		end,
	},
	"General",
	11,
	nil
)

FirstLootEver:RegisterAchievement(20, "Why do they even buy this?", "Obtain any item of poor quality.",
	"Interface\\Icons\\inv_misc_coin_05",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 0 then
			return true
		end
	end,
	{
	},
	"Poor",
	nil,
	29
)

FirstLootEver:RegisterAchievement(29, "Not Ever Rational Directive", "Obtain every known item of poor quality.",
	"Interface\\Icons\\Achievement_BG_killingblow_startingrock",
	function(addon, id)
		if not ((select(3, GetItemInfo(id))) == 0) then return false end
		for itemID, itemOptions in pairs(localfuncs.itemlist()) do
			if itemOptions[2] == "Poor" then
				if not addon.savedVar.items[itemID] then
					return false
				end
			end
		end
		return true
	end,
	{
	},
	"Poor",
	20,
	nil
)

FirstLootEver:RegisterAchievement(40, "Pretty Common", "Obtain any item of common quality.",
	"Interface\\Icons\\Inv_Misc_Toy_01",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 1 then
			return true
		end
	end,
	{
	},
	"Common",
	nil,
	49
)
FirstLootEver:RegisterAchievement(49, "All the Good White stuff", "Obtain every known item of common quality.",
	"Interface\\Icons\\inv_misc_dust_02",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 1 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Common" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Common",
	40,
	nil
)

FirstLootEver:RegisterAchievement(60, "Of the Boar", "Obtain any item of uncommon quality.",
	"Interface\\Icons\\Spell_Magic_PolymorphPig",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 2 then
			return true
		end
	end,
	{
	},
	"Uncommon",
	nil,
	69
)

FirstLootEver:RegisterAchievement(69, "Randomized Collection", "Obtain every known item of uncommon quality.",
	"Interface\\Icons\\INV_Misc_EngGizmos_20",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 2 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Uncommon" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Uncommon",
	60,
	nil
)

FirstLootEver:RegisterAchievement(80, "A Rare Occurrence", "Obtain any item of rare quality.",
	"Interface\\Icons\\Achievement_Halloween_Smiley_01",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 3 then
			return true
		end
	end,
	{
	},
	"Rare",
	nil,
	89
)
FirstLootEver:RegisterAchievement(89, "They're Blue", "Obtain every known item of rare quality.",
	"Interface\\AddOns\\FirstLootEver\\blue",
	function(addon, id)
		if (select(3, GetItemInfo(id))) == 3 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Rare" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Rare",
	80,
	nil
)

FirstLootEver:RegisterAchievement(100, "Truly Epic", "Obtain any item of epic quality.",
	"Interface\\Icons\\Spell_BurningSoul",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 4 then
			return true
		end
	end,
	{
	},
	"Epic",
	nil,
	109
)

FirstLootEver:RegisterAchievement(109, "You CAN haz epix", "Obtain every known item of epic quality.",
	"Interface\\Icons\\INV_Misc_Gift_02",
	function(addon, id)
		if (select(4, GetItemInfo(id))) == 4 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Epic" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Epic",
	100,
	nil
)

local function raidbelowlevel(x)
	if GetNumRaidMembers()<=1 then return false end
	for i=1, GetNumRaidMembers() do
		if UnitLevel("raid"..i) > x then
			return false
		end
	end
	return true
end
FirstLootEver:RegisterAchievement(110, "Been There Done That", "Obtain an epic quality raid loot item from every expansion while no character in your raid group is above that expansion's maximum level.",
	"Interface\\Icons\\Achievement_Dungeon_HEROIC_GloryOfTheRaider",
	function(addon, id, avID)
		local data = localfuncs.itemlist()[id]
		if not data then return end
		if data[2]=="Epic" and (select(2,GetInstanceInfo()))=="raid" then
			if data[4] == "TBC" then
				if raidbelowlevel(70) then
					addon.namespace:WriteAchievementMemory(110,2,true)
				end
			elseif data[4] == "WotLK" then
				if raidbelowlevel(80) then
					addon.namespace:WriteAchievementMemory(110,3,true)
				end
			elseif data[4] == "Cata" then
				if raidbelowlevel(85) then
					addon.namespace:WriteAchievementMemory(110,4,true)
				end
			else
				if raidbelowlevel(60) then
					addon.namespace:WriteAchievementMemory(110,1,true)
				end
			end
			local ns = addon.namespace 
			if ns:ReadAchievementMemory(110,1) and ns:ReadAchievementMemory(110,2) and ns:ReadAchievementMemory(110,3) and ns:ReadAchievementMemory(110,4) then
				return true
			end
		end
	end,
	{
		function(ns)
			local has = ns:ReadAchievementMemory(110,1)
			return "Classic", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0"
		end,
		function(ns)
			local has = ns:ReadAchievementMemory(110,2)
			return "The Burning Crusade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0"
		end,
		function(ns)
			local has = ns:ReadAchievementMemory(110,3)
			return "Wrath of the Lich King", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0"
		end,
		function(ns)
			local has = ns:ReadAchievementMemory(110,4)
			return "Cataclysm", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 0, has and "1" or "0"
		end,
	},
	"Epic",
	nil,
	nil
)


FirstLootEver:RegisterAchievement(120, "Orange is the new Purple","Obtain any item of legendary quality.",
	"Interface\\Icons\\Spell_Fire_Elementaldevastation",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 5 then
			return true
		end
	end,
	{
	},
	"Legendary",
	nil,
	121
)
FirstLootEver:RegisterAchievement(121, "A Dream Come True...", "Obtain one of the legendary quality weapons listed below.",
	"Interface\\Icons\\Achievement_BG_TrueAVShutout",
	function(addon, id)
		if (id == 19019) or (id == 17182) or (id == 32838) or (id == 32837) or (id == 34334) or (id == 46017) or (id == 49623) or (id == 71086) or (id == 77949) or (id == 77950) then
			return true
		end
	end,
	{
		function(ns)
			local has = not not FirstLootEver.savedVar.items[19019]
			return (GetItemInfo(19019)) or "Thunderfury, Blessed Blade of the Windseeker", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 19019, has and "1" or "0", "FirstLootEver_121_1"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[17182]
			return (GetItemInfo(17182)) or "Sulfuras, Hand of Ragnaros", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 17182, has and "1" or "0", "FirstLootEver_121_2"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[32837]
			return (GetItemInfo(32837)).." (Main Hand)" or "Warglaive of Azzinoth (Main Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32837, has and "1" or "0", "FirstLootEver_121_3"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[32838]
			return (GetItemInfo(32838)).." (Off Hand)" or "Warglaive of Azzinoth (Off Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32838, has and "1" or "0", "FirstLootEver_121_4"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[34334]
			return (GetItemInfo(34334)) or "Thori'dal, the Stars' Fury", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 34334, has and "1" or "0", "FirstLootEver_121_5"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[46017]
			return (GetItemInfo(46017)) or "Val'anyr, Hammer of Ancient Kings", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 46017, has and "1" or "0", "FirstLootEver_121_6"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[49623]
			return (GetItemInfo(49623)) or "Shadowmourne", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 49623, has and "1" or "0", "FirstLootEver_121_7"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[71086]
			return (GetItemInfo(71086)) or "Dragonwrath, Tarecgosa's Rest", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 71086, has and "1" or "0", "FirstLootEver_121_8"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[77949]
			return (GetItemInfo(77949)) or "Golad, Twilight of Aspects", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 77949, has and "1" or "0"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[77950]
			return (GetItemInfo(77950)) or "Tiriosh, Nightmare of Ages", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 77950, has and "1" or "0"
		end,
	},
	"Legendary",
	120,
	122
)
FirstLootEver:RegisterAchievement(122, "Wait for it", "Obtain all of the legendary quality weapons listed below.",
	"Interface\\Icons\\Spell_Holy_AvengineWrath",
	function(addon)
		if addon.savedVar.items[19019] and addon.savedVar.items[17182] and addon.savedVar.items[32838] and addon.savedVar.items[32837] and addon.savedVar.items[34334] and addon.savedVar.items[46017] and addon.savedVar.items[49623] and addon.savedVar.items[71086] and addon.savedVar.items[77949] and addon.savedVar.items[77950] then
			return true
		end
	end,
	{
		function(ns)
			local has = not not FirstLootEver.savedVar.items[19019]
			return (GetItemInfo(19019)) or "Thunderfury, Blessed Blade of the Windseeker", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 19019, has and "1" or "0", "FirstLootEver_122_1"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[17182]
			return (GetItemInfo(17182)) or "Sulfuras, Hand of Ragnaros", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 17182, has and "1" or "0", "FirstLootEver_122_2"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[32837]
			return (GetItemInfo(32837)).." (Main Hand)" or "Warglaive of Azzinoth (Main Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32837, has and "1" or "0", "FirstLootEver_122_3"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[32838]
			return (GetItemInfo(32838)).." (Off Hand)" or "Warglaive of Azzinoth (Off Hand)", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 32838, has and "1" or "0", "FirstLootEver_122_4"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[34334]
			return (GetItemInfo(34334)) or "Thori'dal, the Stars' Fury", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 34334, has and "1" or "0", "FirstLootEver_122_5"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[46017]
			return (GetItemInfo(46017)) or "Val'anyr, Hammer of Ancient Kings", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 46017, has and "1" or "0", "FirstLootEver_122_6"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[49623]
			return (GetItemInfo(49623)) or "Shadowmourne", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 49623, has and "1" or "0", "FirstLootEver_122_7"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[71086]
			return (GetItemInfo(71086)) or "Dragonwrath, Tarecgosa's Rest", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 71086, has and "1" or "0", "FirstLootEver_122_8"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[77949]
			return (GetItemInfo(77949)) or "Golad, Twilight of Aspects", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 77949, has and "1" or "0"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[77950]
			return (GetItemInfo(77950)) or "Tiriosh, Nightmare of Ages", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 77950, has and "1" or "0"
		end,
	},
	"Legendary",
	121,
	129
)
FirstLootEver:RegisterAchievement(129, "Just too much spare time", "Obtain every known item of legendary quality.",
	"Interface\\Icons\\Achievement_Dungeon_GloryOfTheRaider",
	function(addon, id)
		if addon:HasAchievement(122) and ((select(3,GetItemInfo(id))) == 5) then
			for itemID, itemOptions in ipairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Legendary" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Legendary",
	122,
	nil
)

FirstLootEver:RegisterAchievement(140, "An Eye for The Eye", "Loot one of the legendary weapons during the Kael'thas Sunstrider encounter in The Eye of Tempest Keep.",
	"Interface\\Icons\\Ability_Hibernation",
	function(addon, id)
		if (id == 30317) or (id == 30316) or (id == 30312) or (id == 30318) or (id == 30313) or (id == 30311) then
			return true
		end
	end,
	{
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30317]
			return (GetItemInfo(30317)) or "Cosmic Infuser", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30317, has and "1" or "0", "FirstLootEver_140_1"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30316]
			return (GetItemInfo(30316)) or "Devastation", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30316, has and "1" or "0", "FirstLootEver_140_2"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30312]
			return (GetItemInfo(30312)) or "Infinity Blade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30312, has and "1" or "0", "FirstLootEver_140_3"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30318]
			return (GetItemInfo(30318)) or "Netherstrand Longbow", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30318, has and "1" or "0", "FirstLootEver_140_4"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30313]
			return (GetItemInfo(30313)) or "Staff of Disintegration", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30313, has and "1" or "0", "FirstLootEver_140_5"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30311]
			return (GetItemInfo(30311)) or "Warp Slicer", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30311, has and "1" or "0", "FirstLootEver_140_6"
		end,
	},
	"Legendary",
	nil,
	141
)
FirstLootEver:RegisterAchievement(141, "Eyeing Completion", "Loot every legendary weapon during the Kael'thas Substrider encounter in The Eye of Tempest Keep.",
	"Interface\\Icons\\Ability_Hunter_AspectOfTheViper",
	function(addon, id)
		if addon.savedVar.items[30317] and addon.savedVar.items[30316] and addon.savedVar.items[30312] and addon.savedVar.items[30318] and addon.savedVar.items[30313] and addon.savedVar.items[30311] then
			return true
		end
	end,
	{
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30317]
			return (GetItemInfo(30317)) or "Cosmic Infuser", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30317, has and "1" or "0", "FirstLootEver_140_1"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30316]
			return (GetItemInfo(30316)) or "Devastation", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30316, has and "1" or "0", "FirstLootEver_140_2"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30312]
			return (GetItemInfo(30312)) or "Infinity Blade", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30312, has and "1" or "0", "FirstLootEver_140_3"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30318]
			return (GetItemInfo(30318)) or "Netherstrand Longbow", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30318, has and "1" or "0", "FirstLootEver_140_4"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30313]
			return (GetItemInfo(30313)) or "Staff of Disintegration", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30313, has and "1" or "0", "FirstLootEver_140_5"
		end,
		function(ns)
			local has = not not FirstLootEver.savedVar.items[30311]
			return (GetItemInfo(30311)) or "Warp Slicer", 0, has, (has and 1 or 0), 1, has and (UnitName("player")), 0, 30311, has and "1" or "0", "FirstLootEver_140_6"
		end,
	},
	"Legendary",
	140,
	nil
)

FirstLootEver:RegisterAchievement(280, "Not Cross-Realm", "Obtain any item of Heirloom quality.",
	"Interface\\Icons\\Achievement_BG_returnXflags_def_WSG",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 7 then
			return true
		end
	end,
	{
	},
	"Heirloom",
	nil,
	281
)

FirstLootEver:RegisterAchievement(281, "Completed Inheritance", "Obtain every known item of Heirloom quality.",
	"Interface\\AddOns\\FirstLootEver\\inheritance",
	function(addon, id)
		if (select(3,GetItemInfo(id))) == 7 then
			for itemID, itemOptions in pairs(localfuncs.itemlist()) do
				if itemOptions[2] == "Heirloom" then
					if not addon.savedVar.items[itemID] then
						return false
					end
				end
			end
			return true
		end
	end,
	{
	},
	"Heirloom",
	280,
	nil
)

FirstLootEver:RegisterAchievementFromTemplate(219, "Raiding for Starters: The Burning Crusade", "Obtain any non-\"Gladiator\" epic item with one of the item levels listed below.",
	"Interface\\Icons\\spell_holy_proclaimchampion",
	"The Burning Crusade",
	nil,
	221,
	"raid_itemlevel_any",
	{115,125,128,134,138,141,151,154,159,164}
)

FirstLootEver:RegisterAchievementFromTemplate(221, "Raiding Veteran: The Burning Crusade", "Obtain at least one non-\"Gladiator\" epic item with each of the item levels listed below.",
	"Interface\\Icons\\spell_holy_championsbond",
	"The Burning Crusade",
	219,
	nil,
	"raid_itemlevel_all",
	{115,125,128,134,138,141,151,154,159,164}
)

FirstLootEver:RegisterAchievementFromTemplate(218, "Raiding for Starters: Wrath of the Lich King", "Obtain any non-\"Gladiator\" epic item with one of the item levels listed below.",
	"Interface\\Icons\\spell_holy_summonchampion",
	"Wrath of the Lich King",
	nil,
	220,
	"raid_itemlevel_any",
	{200,213,219,226,232,239,245,251,264,277,284}
)

FirstLootEver:RegisterAchievementFromTemplate(220, "Raiding Veteran: Wrath of the Lich King", "Obtain at least one non-\"Gladiator\" epic item with each of the item levels listed below.",
	"Interface\\Icons\\inv_misc_frostemblem_01",
	"Wrath of the Lich King",
	218,
	nil,
	"raid_itemlevel_all",
	{200,213,219,226,232,239,245,251,264,277,284}
)

FirstLootEver:RegisterAchievementFromTemplate(222, "Raiding for Starters: Cataclysm", "Obtain any non-\"Gladiator\" epic item with one of the item levels listed below.",
	"Interface\\Icons\\pvecurrency-justice",
	"Cataclysm",
	nil,
	nil,
	"raid_itemlevel_any",
	{359,372,378,379,384,391,397}
)

FirstLootEver:RegisterAchievementFromTemplate(200, "Cataclysmic Collector", "Obtain at least one new item while in each of the listed zones.",
	"Interface\\Icons\\Achievement_Zone_Cataclysm",
	"Cataclysm",
	nil,
	nil,
	"zone_loot_all",
	{"Mount Hyjal", {"Vashj'ir",{"Kelp'thar Forest", "Shimmering Expanse", "Abyssal Depths"}}, "Deepholm", "Uldum", "Twilight Highlands"}
)

FirstLootEver:RegisterAchievementFromTemplate(199, "Frostbitten Collector", "Obtain at least one new item while in each of the listed zones.",
	"Interface\\Icons\\Achievement_Boss_LordMarrowgar",
	"Wrath of the Lich King",
	nil,
	nil,
	"zone_loot_all",
	{"Borean Tundra", "Howling Fjord", "Dragonblight", "Grizzly Hills", "Zul'Drak", "Sholazar Basin", "The Storm Peaks", "Icecrown", "Crystalsong Forest", "Wintergrasp"}
)

FirstLootEver:RegisterAchievementFromTemplate(198, "Collecting Crusade", "Obtain at least one new item while in each of the listed zones.",
	"Interface\\Icons\\achievement_zone_hellfirepeninsula_01",
	"The Burning Crusade",
	nil,
	nil,
	"zone_loot_all",
	{"Hellfire Peninsula", "Zangarmarsh", "Nagrand", "Terokkar Forest", "Blade's Edge Mountains", "Netherstorm", "Shadowmoon Valley"}
)
			
	
-- metas start at 1k. they need to be registered after all others are done to parse just-completed achievements properly
FirstLootEver:RegisterAchievementFromTemplate(1000, "Let's all be friends together", "Obtain at least one item of each quality.",
	"Interface\\Icons\\Achievement_DoubleRainbow",
	"",
	nil,
	1001,
	"achievement_meta",
	{{20,"Poor"},{40,"Common"},{60,"Uncommon"},{80,"Rare"},{100,"Epic"},{120,"Legendary"},{280,"Heirloom"}}
)
FirstLootEver:RegisterAchievementFromTemplate(1001, "Beat The Game", "Obtain every single known item.",
	"Interface\\AddOns\\FirstLootEver\\all",
	"",
	1000,
	nil,
	"achievement_meta",
	{{29,"Every known poor item."},{49,"Every known common item."},{69,"Every known uncommon item."},{89,"Every known rare item."},{109,"Every known epic item."},{129,"Every known legendary item."},{281,"Every known Heirloom item."}}
)




FirstLootEver:RegisterAchievement(1339, "Alpha tester", "Be awesome enough to help with development.",
	"Interface\\Icons\\ThumbsUp",
	function()
		return false
	end,
	{
	},
	"",
	nil,
	1338
)
FirstLootEver:RegisterAchievement(1338, "Repository checkout", "Can't wait for new revisions to package, eh?",
	"Interface\\AddOns\\FirstLootEver\\subversion",
	function()
		return false
	end,
	{
	},
	"",
	1339,
	1337
)
		
FirstLootEver:RegisterAchievement(1337, "Who's awesome?", "You're awesome!",
	"Interface\\AddOns\\FirstLootEver\\treeston",
	function()
		return false
	end,
	{
	},
	"",
	1338,
	nil
)

FirstLootEver.namespace:SetCategoryOrder({
	"General",
	"Poor",
	"Common",
	"Uncommon",
	"Rare",
	"Epic",
	"Legendary",
	"Heirloom",
	"The Burning Crusade",
	"Wrath of the Lich King",
	"Cataclysm",
})

FirstLootEver.namespace:RegenerateAchievementCategoryListings()
end